# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.category_item import CategoryItem  # noqa: F401,E501


class SearchCategory(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'key': 'str',
        'items': 'list[CategoryItem]'
    }

    attribute_map = {
        'key': 'key',
        'items': 'items'
    }

    def __init__(self, key=None, items=None):  # noqa: E501
        """SearchCategory - a model defined in Swagger"""  # noqa: E501

        self._key = None
        self._items = None
        self.discriminator = None

        if key is not None:
            self.key = key
        if items is not None:
            self.items = items

    @property
    def key(self):
        """Gets the key of this SearchCategory.  # noqa: E501


        :return: The key of this SearchCategory.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this SearchCategory.


        :param key: The key of this SearchCategory.  # noqa: E501
        :type: str
        """

        self._key = key

    @property
    def items(self):
        """Gets the items of this SearchCategory.  # noqa: E501


        :return: The items of this SearchCategory.  # noqa: E501
        :rtype: list[CategoryItem]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this SearchCategory.


        :param items: The items of this SearchCategory.  # noqa: E501
        :type: list[CategoryItem]
        """

        self._items = items

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SearchCategory):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
